/*
 * CrystalIRCd - Internet Relay Chat Daemon
 * m_ircops by _loco_ modified for CrystalIRCd by Tiburon
 * All parts of this module and the IRCd are covered in the GNU Public License
 * Changed to support Quake
 */

#include "config.h"
#include "struct.h"
#include "common.h"
#include "sys.h"
#include "numeric.h"
#include "msg.h"
#include "channel.h"
#include <time.h>
#include <sys/stat.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#ifdef _WIN32
#include <io.h>
#endif
#include <fcntl.h>
#include "h.h"
#include "proto.h"
#ifdef STRIPBADWORDS
#include "badwords.h"
#endif
#ifdef _WIN32
#include "version.h"
#endif

DLLFUNC int m_ircops(aClient * cptr, aClient * sptr, int parc, char *parv[]);
/* Place includes here */
#define MSG_IRCOPS       "IRCOPS" /* dummy */
#define TOK_IRCOPS       "IOP"    /* 127 4ever !;) */

#ifndef DYNAMIC_LINKING
ModuleHeader m_ircops_Header
#else
#define m_ircops_Header Mod_Header
ModuleHeader Mod_Header
#endif
  = {
        "ircops",        /* Name of module */
	"$Id: m_ircops.c,v 1.1.4.14 2002/05/20 19:43:13 _loco_ translated by Tiburon Exp $", /* Version */
        "command /ircops", /* Short description of module */
        "2.5",
        NULL
    };
#ifdef DYNAMIC_LINKING
DLLFUNC int     Mod_Init(ModuleInfo *modinfo)
#else
int    m_ircops_Init(ModuleInfo *modinfo)
#endif
{
        /*
         * We call our add_Command crap here
        */
        add_Command(MSG_IRCOPS, TOK_IRCOPS, m_ircops, MAXPARA);
}

/* Is first run when server is 100% ready */
#ifdef DYNAMIC_LINKING
DLLFUNC int     Mod_Load(int module_load)
#else
int    m_ircops_Load(int module_load)
#endif
{
}


/* Called when module is unloaded */
#ifdef DYNAMIC_LINKING
DLLFUNC int     Mod_Unload(int module_unload)
#else
int     m_ircops_Unload(int module_unload)
#endif
{
        if (del_Command(MSG_IRCOPS, TOK_IRCOPS, m_ircops) < 0)
        {
                sendto_realops("Failed to delete commands when unloading %s",
                                m_ircops_Header.name);
        }
}

DLLFUNC int m_ircops(aClient * cptr, aClient * sptr, int parc, char *parv[])
{
    aClient *acptr;
    int totalops = 0;
    char *stat, buf[200];

    /* if (!IsOper(cptr)) { */
    sendto_one(cptr, ":%s 009 %s :  Quake On-Line Operator List  ",
        me.name, cptr->name);
    sendto_one(cptr, ":%s 009 %s :                                                                       ",
        me.name, cptr->name);
    sendto_one(cptr, ":%s 009 %s :\2Nick\2                           Status                      \02Server\02", me.name, cptr->name);
    sendto_one(cptr, ":%s 009 %s :",
		me.name, cptr->name);

    for (acptr = client; acptr; acptr = acptr->next)
    {
        if (IsPerson(acptr) && IsAnOper(acptr) && !IsULine(acptr) && !IsHideOper(acptr))
        {
            buf[0] = '\0';
            sendto_one(cptr, ":%s 009 %s :%-30s  %-9s %-9s  %s",me.name, cptr->name,
                    acptr->name ? acptr->name : "<Desconhecido>",
                    IsCoder(acptr) ? "IRC Administrator" : IsNetAdmin(acptr) ? "Network Administrator" : IsTechAdmin(acptr) ? "Technical Administrator" : IsSAdmin(acptr) ? "Services Administrator" : IsAdmin(acptr) ? "Server Administrator" : IsCoAdmin(acptr) ? "Co-Administrator" : IsOper(acptr) ? "Global Operator" : "Local Operator",
                    acptr->user->away ? "(Away)" : "",
                    acptr->user->server);

           totalops++;
        }
    }
    if (totalops == 0)
        sendto_one(cptr, ":%s 009 %s :No On-Line IRCops. ",me.name, cptr->name);
    sendto_one(cptr, ":%s 009 %s :",
        me.name, cptr->name);
    sendto_one(cptr, ":%s 009 %s :Total:  %d  Operator(s) connected.", me.name, cptr->name, totalops);
    sendto_one(cptr, ":%s 009 %s :",
        me.name, cptr->name);

}
